#!/bin/bash
# $Revision: 1.4 $
# STANDARD 1.0
# PLUGIN TYPE:LIST
# PLUGIN LIST:irc.kiss0fdeath.net #BlockBuster

######################################################################
echo "BEGIN: $(basename $0) $*" >&2
######################################################################
# Questo e' un "bash script plugin" per BuDuScRiPt/budus_xdcc.sh

# Il suo scopo e' quello di fornire un "motore di ricerca".

######################################################################
function make_data_file_exchange() {
    search_result=$(cat /tmp/budus_XDCC_db_${plugin_name}.${date_code})
    for pattern in ${SEARCH_STRING}; do
	search_result=$(echo "${search_result}" | grep -iF "${pattern}")
    done
    
    echo "${search_result}" > ${plugin_tempfile}.database
}

######################################################################
# Lo script "budus_xdcc.sh" invoca questo script passando, come primo
# parametro, un codice casuale che serve per calcolare il file dentro
# al quale immagazzinare il risultato opportunamente filtrato.
RANDOM_NUMBER=${1}

# Il secondo parametro e' il numero di secondi d'attesa del risultato
# dal sito web interrogato, trascorsi i quali, si deve interrompere la
# ricerca del plugin.
WGET_TIMEOUT=${2}

# Il terzo parametro rappresenta la "stringa di ricerca" immessa
# dall'utente.
SEARCH_STRING=${3}

######################################################################
# Viene calcolato il nome del file dati dentro al quale immagazzinare
# il risultato.
date_code=$(date +%Y%m%d)
plugin_path=$(dirname "${0}")
plugin_name=$(echo "${0}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
user_home=$(echo "${HOME}" | tr [:punct:] '_')
plugin_tempfile=/tmp/budus_XDCC_${plugin_name}_${user_home}_${RANDOM_NUMBER}

######################################################################
# Questo plugin, scaricando una lista anziche' interrogando un motore
# di ricerca web, lavore in modo diverso: salva il risultato
# "giornaliero" (cioe' lo aggiorna solo una volta al giorno)
if [ -f /tmp/budus_XDCC_db_${plugin_name}.${date_code} ]; then
    make_data_file_exchange
    
    rm -f ${plugin_tempfile}
    echo "END  : $(basename $0) $*" >&2
    exit 0;
else
    rm -f /tmp/budus_XDCC_db_${plugin_name}.*
fi

######################################################################
# VARIABILI AD USO DEL FILTRO
######################################################################
db_url_1="http://cartoonworld.altervista.org/xdcc/index.php"
db_url_2="http://www.bestripcrew.altervista.org/xdcc/"
wget_option="-q -t 1 -O - -T ${WGET_TIMEOUT}"

######################################################################
wget ${wget_option} ${db_url_1} | sed 's/\r//g'  > ${plugin_tempfile}
wget ${wget_option} ${db_url_2} | sed 's/\r//g' >> ${plugin_tempfile}
cp -f ${plugin_tempfile} /tmp/budus_XDCC_db_${plugin_name}.dat

######################################################################
if [ ! -f "${plugin_tempfile}" ]; then
    echo > "${plugin_tempfile}"
    if [ ! -f "${plugin_tempfile}" ]; then
	echo "/ECHO %C4,1Non sono in grado di creare files temporanei in /tmp, problema di permessi ?"
	echo "/ECHO (${plugin_tempfile})"
	exit 1;
    else
	echo "/ECHO %C4,1Il plugin non e' stato in grado di generare il database. Segnalare il problema a UDA'Software, se persiste."
	exit 1;
    fi
fi

######################################################################
# Filtraggio
# L'output del filtro e' rappresentato da 8 campi separati dal
# carattere di tabulazione '\t', ovvero:
# NETWORK_NAME NETWORK_HOST CHANNEL BOT_NAME ID FILE_NAME SIZE COMMAND
#       1            2         3        4    5      6      7      8
######################################################################
# ATTENZIONE: IN QUESTO XBSPSE VIENE UTILIZZATO UN FILTRO A "STADIO
# MULTIPLO".
{
    NETWORK_NAME="kiss0fdeath"
    NETWORK_HOST="irc.kiss0fdeath.net"
    CHANNEL="#BlockBuster"
    
    IFS=$'\n'
    for record in $(cat ${plugin_tempfile} \
	| sed 's@<table class="lista"><tr><th colspan="4">@\nBUDUS_BOT_NAME@g' \
	| grep -F 'BUDUS_BOT_NAME' \
	| sed 's@^BUDUS_BOT_NAME@@g' \
	| sed 's@</th>@\t@g'); do
	BOT_NAME=$(echo "${record}" | awk -F'\t' '{print $1}')
	
	echo "${record}" \
	    | awk -F'\t' '{print $2}' \
	    | sed 's@<a href=".">@\n@g' \
	    | sed 's@</a></td></tr><tr><td>@\t@g' \
	    | sed 's@ *</td><td>@\t@g' \
	    | sed 's@</td><td class="data">.*@@g' \
	    | sed 's@&lt;@<@g' \
	    | grep -v '<.*>' \
	    | awk -v NETWORK_NAME="${NETWORK_NAME}" -v NETWORK_HOST="${NETWORK_HOST}" -v CHANNEL="${CHANNEL}" -v BOT_NAME="${BOT_NAME}" -F'\t' '{print NETWORK_NAME"\t"NETWORK_HOST"\t"CHANNEL"\t"BOT_NAME"\t"$2"\t"$1"\t"$3"\t/MSG "BOT_NAME" XDCC SEND "$2}'
    done
} > /tmp/budus_XDCC_db_${plugin_name}.${date_code}

make_data_file_exchange

######################################################################
rm -f ${plugin_tempfile}

######################################################################
echo "END  : $(basename $0) $*" >&2
######################################################################